variables:
  MONGO_INITDB_ROOT_USERNAME: "admin"
  MONGO_INITDB_ROOT_PASSWORD: "admin"

default:
  image: node:16.13.0

  before_script:
    - "[ ! -f package-lock.json ] && npm i"
    - npm ci --cache .npm --prefer-offline

  cache:
    key: $CI_COMMIT_REF_SLUG
    paths:
      - .npm/

workflow:
  rules:
    - if: '$CI_PIPELINE_SOURCE == "merge_request_event"'
    - if: '$CI_COMMIT_BRANCH'

stages:
  - build
  - test
  - deploy

audit-job:
  stage: build
  allow_failure: true
  script:
    - npm audit --audit-level=high

lint-job:
  stage: build
  script:
    - npm run lint

build-job:
  stage: build
  script:
    - npm run build

test-job:
  stage: test
  services:
    - name: mongo:4.4
      alias: mongodb
  script:
    - npm run test:ci

# It deploys in pre-production environment by default, as there is no develop branch
deploy-job:
  stage: deploy
  variables:
    SERVICE_NAME: "world"
    TARGET_ENV: "pre-production"
  trigger:
    include:
      - project: 'horsemen-and-women-of-the-apocalypse/rpg-of-the-apocalypse/common-ci-cd'
        ref: 'init-cd' # TODO: Change to develop
        file: '.service-gitlab-ci.yml'
    strategy: depend
  # only: master

# Production deployment is done manually
# production-deploy-job:
#   stage: deploy
#   variables:
#     SERVICE_NAME: "world"
#   trigger:
#     include:
#       - project: 'horsemen-and-women-of-the-apocalypse/rpg-of-the-apocalypse/common-ci-cd'
#         ref: 'init-cd'
#         file: '.service-gitlab-ci.yml'
#   when: manual
  # only: master 